//********************************************************************************
//
// Spherical coordinates representing a 3D vector.
//
// http://en.wikipedia.org/wiki/Spherical_coordinates
//
// Original author: Rob Baker.
// Current maintainer: Rob Baker.
//
//********************************************************************************

#pragma once
#pragma managed(push,off)


//********************************************************************************
// Normalise this coordinate returning its length.
//********************************************************************************

LIBMATHS_INLINE F32 Spherical3::Normalise(void)
{
	F32 length = _radius;
	
	_radius = 1.0f;
	
	return length;
}

#pragma managed(pop)
