//********************************************************************************
//
// Defines simple 2D triangles. Intended mainly for collision and ray intersection
// testing.
//
// Original author: Rob Baker.
// Current maintainer: Rob Baker.
//
//********************************************************************************


//********************************************************************************
// Include the required header files.
//********************************************************************************

#include "triangle2.h"


namespace libmaths
{

	//********************************************************************************
	// Check if the given point is inside the triangle.
	//********************************************************************************

	Bool Triangle2::Contains(const Vector2& point) const
	{
		// TODO: Write this code.
		LIBMATHS_ASSERT(0 && "Not yet implemented");

		return false;
	}


	//********************************************************************************
	// Check if a ray of given origin and direction intersects the triangle.
	//********************************************************************************

	Bool Triangle2::Intersects(const Ray2& ray) const
	{
		Vector2 point, normal;

		return (Intersects(ray, point, normal));
	}


	//********************************************************************************
	// Check if a ray of given origin and direction intersects the triangle.
	//********************************************************************************

	Bool Triangle2::Intersects(const Ray2& ray, Vector2& point, Vector2& normal) const
	{
		// TODO: Write this code.
		LIBMATHS_ASSERT(0 && "Not yet implemented");

		return false;
	}


	//********************************************************************************
	// Squared distance of point from triangle. Closest point is returned in
	// intersection.
	//********************************************************************************

	F32 Triangle2::DistanceSqr(const Vector2& point, Vector2& intersection) const
	{
		// TODO: Write this code.
		LIBMATHS_ASSERT(0 && "Not yet implemented");

		return 0.0f;
	}


	//********************************************************************************
	// Distance of point from triangle. Closest point is returned in intersection.
	//********************************************************************************

	F32 Triangle2::Distance(const Vector2& point, Vector2& intersection) const
	{
		return libmaths::Sqrt(DistanceSqr(point, intersection));
	}

// namespace libmaths
}
